@echo off
REM
REM batch script para adelgazamiento de primeros ecos a 9 primeros ecos por metro cuadrado individual en modo random -step 0.33
REM con un angulo de +/- 20grados y escalamiento a centimetro en coordenadas 3D
REM
REM incluir LAStools en PATH para usar el script de cualquer lugar
set PATH=%PATH%;..;C:\lastools\bin;


REM ===================================================
REM = DESDE AQUI UNO TIENE QUE CAMBIAR LOS PARAMETROS =
REM ===================================================
echo START Automatic Pointcloud Classification %TIME% %DATE% >>%OUTPUT_FILES%\NDP_log.txt

REM especificar la ruta en cual se guarda la NDP clasificada
set INPUT_FILES=f:\PROYECTOS\2794_1804_LiDAR_Masa_2018\_delivery_AjusteXYZ_Elipsoidal_2349a2350\CutPolygon\Falta_Filtro\CutPolygon\

REM especificar la ruta por los resultados
set OUTPUT_FILES=f:\PROYECTOS\2794_1804_LiDAR_Masa_2018\_delivery_AjusteXYZ_Elipsoidal_2349a2350\CutPolygon\Falta_Filtro\CutPolygon\Filtrados\

set TEMP=f:\PROYECTOS\2794_1804_LiDAR_Masa_2018\_delivery_AjusteXYZ_Elipsoidal_2349a2350\CutPolygon\Falta_Filtro\CutPolygon\Temporales\

REM especificar el format de los archivos
set IN_FORMAT=las

REM especificar los nucleos de computador para usar (default todos los nucleos - 1)
set NUM_CORES
set /A NUM_CORES=%NUMBER_OF_PROCESSORS% - 1

REM ===============================================
REM = DESDE AQUI TODO ESTA LISTO PARA EL PROCESSO =
REM ===============================================
mkdir %TEMP%
REM busca ecos duplicados y ecos de traslape (overage) entré lineas de vuelo y eliminarlos (see: lasduplicate_README.txt y lasoverage_README.txt)
mkdir %TEMP%\overlap
mkdir %TEMP%\duplicate
mkdir %TEMP%\sort
mkdir %TEMP%\step25
mkdir %OUTPUT_FILES%
mkdir %OUTPUT_FILES%\informes
lasduplicate64 -i %INPUT_FILES%\*.%IN_FORMAT% -unique_xyz -odir %TEMP%\duplicate -olaz
echo lasduplicate END %TIME% %DATE% >>%OUTPUT_FILES%\NDP_log.txt
echo lasduplicate END %TIME% %DATE%

REM detección de puntos identicos en distintas líneas 
lasoverage64 -i %TEMP%\duplicate\*.laz -step %STEP% -remove_overage -odir %TEMP%\overlap -olaz
echo lasoverage END %TIME% %DATE% >>%OUTPUT_FILES%\NDP_log.txt
echo lasoverage END %TIME% %DATE%

REM cambio del orden de puntos en el archivo en forma de hora de grabación y numero de eco
lassort64 -i %TEMP%\overlap\*.laz -gps_time -return_number -odir %TEMP%\sort -olaz
echo lassort END %TIME% %DATE% >>%OUTPUT_FILES%\NDP_log.txt
echo lassort END %TIME% %DATE%
las2las -i %TEMP%\sort\*.laz ^
		-rescale 0.01 0.01 0.01 -keep_scan_angle -20 20 ^
		-odir %TEMP% -olaz ^
		-cpu64 -cores %NUM_CORES%
lasgrid -i %TEMP%\sort\*.laz ^
        -first_only -counter -step 1 -false -set_min_max 3 5 ^
        -odir %OUTPUT_FILES%\informes -odix density_4_pts_original -otif ^
		-cores %NUM_CORES%
lasthin -i %TEMP%\*.laz ^
        -first_only -subcircle 0.1 ^
		-filtered_transform -step 0.25 -central ^
        -odir %TEMP%\step25 -olaz -odix _filtroysubcircle_0.25 ^
		-cpu64 -cores %NUM_CORES%
lasthin -i %TEMP%\step25\*.laz ^
        -first_only -filtered_transform -step 0.33 -central ^
        -odir %OUTPUT_FILES% -olaz -odix _filtro_0.33 ^
		-cpu64 -cores %NUM_CORES%
lasinfo -v -i %OUTPUT_FILES%\*.laz -first_only -otxt -odir %OUTPUT_FILES%\informes -cd
lasgrid -i %OUTPUT_FILES%\*.laz ^
        -first_only -counter -step 1 -false -set_min_max 3 5 ^
        -odir %OUTPUT_FILES%\informes -odix density_4_pts_filtro_0.33 -otif ^
		-cores %NUM_CORES%

lasgrid -i %OUTPUT_FILES%\*.laz ^
        -first_only -counter -step 1 -false -set_min_max 8 10 ^
        -odir %OUTPUT_FILES%\informes -odix density_9_pts_filtro_0.33 -otif ^
		-cores %NUM_CORES%

rmdir %TEMP%	

echo End Automatic Pointcloud Classification %TIME% %DATE% \n >>%OUTPUT_FILES%\NDP_log.txt
